﻿if not globalfunctions then
  globalfunctions = true;

  -- Convert GetProfessions into an table
  function TG_TS_GetProfessions()
    local skills =  {};
    local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
    tinsert(skills, prof1);
    tinsert(skills, prof2);
    tinsert(skills, archaeology);
    tinsert(skills, fishing);
    tinsert(skills, cooking);
    tinsert(skills, firstAid);
    return skills;
  end
  
  -- LEARNITEM Completer
  function TG_TS_LEARNITEM(msg)
    if msg:match("You have learned how to create a new item: ([%a:%s]+).") then
      -- Get item name to learn
      local ItemName = TourGuide.tags[TourGuide.current]:match("|LEARNITEM|([%a:%s]+)|");
      -- Get item nave of just learned
      local LearnedItemName = msg:match("You have learned how to create a new item: ([%a:%s]+).");

      -- Compleate if match
      if (strtrim(ItemName) == strtrim(LearnedItemName)) then
        TourGuide:SetTurnedIn(TourGuide.current, true);
      end
    end
  end

  -- LOOT Completer
  function TG_TS_LOOT()
    local lootitem, lootqty = TourGuide.tags[TourGuide.current]:match("|LOOT|(%d+)%s?(%d*)|");
    lootqty = tonumber(lootqty) or 1;
    local itemName = GetItemInfo(lootitem);
    TourGuide.statusframe.extend.text:SetText(string.format("%i of %i %s", GetItemCount(lootitem), lootqty, itemName))
    if (GetItemCount(lootitem) >= lootqty) then
      TourGuide:SetTurnedIn(TourGuide.current, true);
    end
  end

  -- LVLTOSKILL Completer
  function TG_TS_LVLTOSKILL()
    local SkillName, SkillLevel = TourGuide.tags[TourGuide.current]:match("|LVLTOSKILL|([%a:%s]+)%s?(%d+)|");
    SkillName = strtrim(SkillName);
    SkillLevel = tonumber(SkillLevel) or 1;
    for _, sID in ipairs(TG_TS_GetProfessions()) do
      if sID then
        local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)
        if SkillName == sName then
          TourGuide.statusframe.extend.text:SetText(string.format("Skill %i of %i", tonumber(sLevel), SkillLevel));
          if SkillLevel <= tonumber(sLevel) then
            TourGuide:SetTurnedIn(TourGuide.current, true);
          end
        end
      end
    end
  end
  
  -- LVL Completer
  function TG_TS_LVL(level)
    lvl = tonumber(TourGuide.tags[TourGuide.current]:match("|LVL|(%d+)|"))
    if level then
      if lvl and lvl <= tonumber(level) then
        TourGuide:SetTurnedIn(TourGuide.current, true);
      end
    else
      if lvl and lvl <= UnitLevel("Player") then
        TourGuide:SetTurnedIn(TourGuide.current, true);
      end
    end
  end

  -- SKILL Completer
  function TG_TS_SKILL()
    local SkillName, SkillLevel = TourGuide.tags[TourGuide.current]:match("|SKILL|([%a:%s]+)%s?(%d+)|");
    SkillName = strtrim(SkillName);
    SkillLevel = tonumber(SkillLevel) or 1;

    -- Loop all curent skill and check if the skill match
    for _, sID in ipairs(TG_TS_GetProfessions()) do
      if sID then
        local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)
        if SkillName == sName and SkillLevel <= tonumber(sLevel) then
          TourGuide:SetTurnedIn(TourGuide.current, true);
        end
      end
    end
  end

  function TG_TS_TRAINSKILL(msg)
    local SkillName, MaxSkillLevel = TourGuide.tags[TourGuide.current]:match("|TRAINSKILL|([%a:%s]+)%s?(%d+)|");
    SkillName = strtrim(SkillName);
    MaxSkillLevel = tonumber(MaxSkillLevel) or 75;
    if msg then
      local abilityname = strtrim(msg:match("You .+%[(.+)%]."));
      -- Get Skill info to check
      SkillName = strtrim(SkillName);
      -- If Ability name and skillname match
      if abilityname == SkillName then
        TourGuide:SetTurnedIn(TourGuide.current, true);
      end
    else
      for _, sID in ipairs(TG_TS_GetProfessions()) do
        if sID then
          local sName, _, _, maxSLevel, _, _, _, _ = GetProfessionInfo(sID)
          if SkillName == strtrim(sName) and (MaxSkillLevel - 75) == tonumber(maxSLevel) or MaxSkillLevel == tonumber(maxSLevel) then
            TourGuide:SetTurnedIn(TourGuide.current, true);
          end
        end
      end
    end
  end
end